#!/usr/local/bin/perl 
$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools";
#-------------------------------------------------------------------------
#    Name:  dbamon_dbms.pl
#
# Version:  @(#)$Revision$
#
# Purpose:  
#
#   Specs: 
#
#  Author:  Bill Border
#-------------------------------------------------------------------------
$| = 1;
chop($P = `basename $0`);
require "cgi_handlers.pl";

# Read WWW_Check:
chop($font = `grep 'WWW_Font:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
if ($font =~ /%/)
{
  $font =~ s/%/ /g;
  $font = "'$font'";
}

$fs = "<font face='$font' size=2>";

$in_dbms = "";
$in_ver  = "";
$in_os   = "";

# Trap an interrupt signal and clean up
$SIG{'INT'} = 'IntHandler';

# Require the DBI module and the DBD::mysql driver
use DBI;
require "cgi_handlers.pl";

$img_blue   = "/dbamon/img/blue.gif";
$img_red    = "/dbamon/img/red.gif";
$img_green  = "/dbamon/img/green.gif";
$img_yellow = "/dbamon/img/yellow.gif";

chop($date     = `date`);
##chop($host     = `hostname`);

$database = "dbamon";

# See if DBAmon is configured to use Oracle
chop($use_oracle  = `grep Use_Oracle:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_SID  = `grep ORACLE_SID:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_HOME = `grep ORACLE_HOME: /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
if ($use_oracle eq "Y" && $ORACLE_SID ne "" && $ORACLE_HOME ne "")
{
  $ENV{'ORACLE_SID'}  = $ORACLE_SID;
  $ENV{'ORACLE_HOME'} = $ORACLE_HOME;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $ORACLE_SID;
  $dbms = "oracle";
}

#-----------------------------------------------------------------------------
sub error
#-----------------------------------------------------------------------------
{
  local($errorMsg) = @_;

  #print "Content-type: text/html\n\n";
  print "<head><title> Database Function Error - Output</title></head>";
  print "<body>";

  print "<h3> The following database error occured - $date<hr></h3>";
  print "</hr noshade>";
  print "<h4> $errorMsg $DBI::errstr</h4>";
  print "SQL statement: <pre>$sql</pre>";

  &PrintLinks;

  print "</body>";
  print "</html>";

  $emsg = $_[0];
  $sqlerror = $DBI::errstr;
  print "==========================================\n";
  print "Fatal Error: $emsg - $sqlerror\n";
  print "==========================================\n";
  chop($admin_email = `grep Admin_EMail: /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
  system("echo \"$P - DBAmon Master Server: $hostname\" | mailx -s \"DBAmon Fatal Error: $P - $emsg - $sqlerror\" $admin_email");

  exit(1);
}

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  my $msg     = $_[0];
  my $msgflag = $_[1];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  my $br = "<br>" if ! $msgflag;
  print "$br <font size=2>$date ${P} | <b>$msg</b></font>\n";
}

#------------------------------------------------------------------------------
sub makeReport
#------------------------------------------------------------------------------
{
  &msg("Reading DBAMON.SUMMARY_DETAIL data");

  $sql  = "
    select
      title,
      dbms
    from 
      dbamon.summary_detail
    where
      dbamonmode = '$in_mode'
    order by
      1, 2";

  ##print "statement=$statement\n";

  $sth2 = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth2->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $rowcount=0;

  print "<p>
  <table bgcolor=linen bordercolor=white border=1>
    <tr bgcolor=slate>
      <th>$fs Instance
      <th>$fs DBMS
  ";

  while (@Data = $sth2->fetchrow_array)
  {
    $rowcount++;
    $title  = shift @Data;
    $dbms   = shift @Data; 

    print "
      <tr>
        <td>$fs $title
        <td>$fs $dbms
    "; 
  }

  print "</table>";

  &msg("Read $rowcount rows");
}

#-----------------------------------------------------------------------------
sub displayError
#-----------------------------------------------------------------------------
{
   local($errorMsg) = @_;

   print "Content-type: text/html\n\n";
   print "<head><title> Database Function Error - Output</title></head>";
   print "<body><font face=$font>";

   print "<h2> The following database error occured - $date</h2>";
   print "<hr noshade>";
   print "</hr noshade>";
   print "<h4> $errorMsg</h4>";
   $sqlerror = $DBI::errstr;
   print "<br>SQL statement: $statement";
   print "<br>SQL error: $sqlerror";

   &PrintLinks;

   print "</body>";
   print "</html>";

   exit(1);
}

#-----------------------------------------------------------------------------
sub connectDB 
#-----------------------------------------------------------------------------
{
  # Connect to the Mysql database
  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
         &displayError('Failed_on_DB_connect_in_updateDb');
}

#-----------------------------------------------------------------------------
sub loadHash
#-----------------------------------------------------------------------------
{
  &msg("Retrieving Data - Please wait ...");
  $s_time = time;

  # Create the SQL SELECT statement
  $statement  = "
    select 
      dbms, 
      dbmsver,
      os,
      count(*) count
    from 
      instances 
    where 
      dbamonmode like 'prod%'
      and dbmsver is not null
    group by
      dbms,
      dbmsver,
      os
  ";
  ##print "$statement\n";

  $sth = $dbh->prepare($statement) ||
          &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  $e_time = time;
  $elapsed += $e_time - $s_time;

  $selectcount = 0;
  $gtotal_count = 0;

  while ($rowhash = $sth->fetchrow_hashref('NAME_lc'))
  {
    $rowcount++;

    $dbms    = $rowhash->{dbms};
    $dbmsver = $rowhash->{dbmsver};
    $os      = $rowhash->{os};
    $dbms_count   = $rowhash->{count};

    $dbms =~ s/ //g;

    if ($os =~ /^Linux/) { $os_fam = "Linux"; }
    elsif ($os =~ /^Sun/) { $os_fam = "Sun"; }
    elsif ($os =~ /^NT-4/) { $os_fam = "NT-4"; }
    elsif ($os =~ /^NT-5/) { $os_fam = "NT-5"; }
    elsif ($os =~ /^UX-10/) { $os_fam = "UX-10"; }
    elsif ($os =~ /^UX-11/) { $os_fam = "UX-11"; }
    else  { $os_fam = $os; }

    if ($dbms =~ /^Oracle/)
    {
      $dbms_fam = 
        (split(/\./,$dbmsver)) [0] . '.' .
        (split(/\./,$dbmsver)) [1] . '.' .
        (split(/\./,$dbmsver)) [2];
    }
    elsif ($dbms =~ /^SAP/)
    {
      $dbms_fam = substr($dbmsver,0,3);
    }
    else
    {
      $dbms_fam = 
        (split(/\./,$dbmsver)) [0] . '.' .
        (split(/\./,$dbmsver)) [1];
    }
   

    ##print "dbms_fam=$dbms_fam dbms_and_ver=$dbms_and_ver dbms_count=$dbms_count\n";
   
    #---- Increment hash
    $zkey = "$dbms/$dbms_fam/$os_fam";
    $zkey =~ s/ //g;
    $dbms{"$zkey"} += $dbms_count;

    $gtotal_count += $dbms_count;

    #---- Check for compliance
    ($zdbmsver = $dbmsver) =~ s/^0//;
    $rc = &checkSWVer($zdbmsver,$dbms);
    ##print "<br>dbmsver=$zdbmsver dbms=$dbms rc=$rc\n";
    
    #$swver_in{$zkey} = 0;
    #swver_out{$zkey} = 0;
    #swver_na{$zkey} = 0;

    if    ($rc == 0) { $swver_in{"$zkey"}  += $dbms_count; }
    elsif ($rc == 1) { $swver_out{"$zkey"} += $dbms_count; }
    else             { $swver_na{"$zkey"}  += $dbms_count; }

  }
}

#-----------------------------------------------------------------------------
sub byVerReport
#-----------------------------------------------------------------------------
{
  &msg("Retrieving Data for in_dbms=$in_dbms in_ver=$in_ver in_os=$in_os");
  $s_time = time;

  # Create the SQL SELECT statement
  $sql  = "
    select 
      system, 
      instance,
      dbmsver,
      os
    from 
      instances 
    where 
      dbamonmode like 'prod%'
      and dbms = '$in_dbms'
      and dbmsver like '$in_ver%'
      and os like '$in_os%'
    order by
      1, 2
  ";
  ##print "$sql\n";

  $sth = $dbh->prepare($sql) || &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  $e_time = time;
  $elapsed += $e_time - $s_time;

  $selectcount = 0;

  print "<hr><table bgcolor=lightblue>
    <tr bgcolor=slate>
      <th>$fs Instances Running<br>$in_dbms $in_ver on $in_os
      <th>$fs Operating<br>System
      <th>$fs Specific<br>Version
      <th>$fs DBMS<br>Version<br>Family 
      <th>$fs Min. Good<br>Version For<br>This Family 
      <th>$fs DBMS Version Status
  ";

  while ($rowhash = $sth->fetchrow_hashref('NAME_lc'))
  {
    $rowcount++;

    $system   = $rowhash->{system};
    $instance = $rowhash->{instance};
    $dbmsver  = $rowhash->{dbmsver};
    $os       = $rowhash->{os};

    $dbmsver =~ s/^0//g;

    $rc = &checkSWVer($dbmsver,$in_dbms);
    if ($rc == 1) 
    {
      $swver_color = "pink";
    }
    elsif ($rc == 0) 
    {
      $swver_color = "lime";
    }
    else 
    {
      $swver_color = "yellow";
    }

    print "<tr bgcolor=wheat>
      <td>$fs <b> $system / $instance 
      <td>$fs <b>$os
      <td bgcolor=$swver_color>$fs <b>$dbmsver
      <td bgcolor=$swver_color>$fs <b>$this_family
      <td bgcolor=$swver_color>$fs <b>$this_minver
      <td bgcolor=$swver_color>$fs <b>$swver_msg
    \n";
  }

  print "</table>\n";
  
  if ($rowcount == 0)
  {
    &msg("ERROR: No rows found - sql=<pre>$sql</pre>");
  }
}

#-----------------------------------------------------------------------------
sub createReport
#-----------------------------------------------------------------------------
{
  print "
  <hr>
  <table bgcolor=lightblue>
  ";
  foreach $this_key (sort keys %dbms)
  {
    $this_dbms  = (split(/\//,$this_key)) [0];
    $this_fam   = (split(/\//,$this_key)) [1];
    $this_os    = (split(/\//,$this_key)) [2];
    $this_count = $dbms{$this_key};

    ($this_fam_dis = $this_fam) =~ s/^0//g;

    ##print "this_key=$this_key this_dbms=$this_dbms this_fam=$this_fam\n";

    $zpct    = ($this_count / $gtotal_count) * 100;
    $zpct    = sprintf("%.2f",$zpct);
    $zfactor = $zpct * 3; 
    $zurl    = "<a href='/cgi-bin/$P?$this_dbms,$this_fam,$this_os'>$this_dbms $this_fam_dis on $this_os</a>";

    if ($this_dbms ne $last_dbms)
    {
      if ($swver_total > 0)
      {
        $zpct_t    = ($swver_compliant / $swver_total) * 100;
        $zpct_t    = sprintf("%.2f",$zpct_t);
        print "<tr bgcolor=slate><th colspan=99> $fs <font size=2> 
          DBMS: $last_dbms Compliance: Total $swver_compliant/$swver_total = ${zpct_t}% </font>";
      }
      print "
	<tr bgcolor=darkblue><th colspan=99> $fs <font size=3 color=white> DBMS: $this_dbms </font>
	<tr bgcolor=slate>
	  <th>$fs DBMS Version Family<br>And OS
	  <th>$fs Instance<br>Count
	  <th colspan=2>$fs % Of All Instances<br>(All DBMS's)
	  <th>$fs Instances<br>*IN*<br>Compliance
	  <th>$fs Instances<br>*OUT* Of<br>Compliance
	  <th>$fs Instances<br>Missing<br>SWVER<br>Definition
	  <th colspan=2>$fs % Of Instances That<br>Are *IN* Compliance
      ";

      $swver_total     = 0;
      $swver_compliant = 0;
    }

    if    ($this_dbms =~ /Oracle/)   { $this_img = $img_red; }
    elsif ($this_dbms =~ /MSSQL/)    { $this_img = $img_green; }
    elsif ($this_dbms =~ /Informix/) { $this_img = $img_blue; }
    else                             { $this_img = $img_yellow; }

    $zpct_compliant    = ($swver_in{$this_key} / $this_count) * 100;
    $zpct_compliant    = sprintf("%.2f",$zpct_compliant);
    $zfactor_compliant = $zpct_compliant * 1; 

    $swver_total += $this_count;
    $swver_compliant += $swver_in{$this_key};

    print "<tr bgcolor=wheat>
      <td><b>$fs $zurl
      <td align=right>$fs <b>$this_count
      <td align=right>$fs <b>${zpct}%
      <td><img src='$this_img' height=15 width=$zfactor> 
      <td align=right bgcolor=lime>$fs <b>$swver_in{$this_key}
      <td align=right bgcolor=pink>$fs <b>$swver_out{$this_key}
      <td align=right bgcolor=yellow>$fs <b>$swver_na{$this_key}
      <td align=right>$fs <b>${zpct_compliant}%
      <td><img src='$this_img' height=15 width=$zfactor_compliant> 
    \n";

    $last_dbms = $this_dbms;
  }

  if ($swver_total > 0)
  {
    $zpct_t    = ($swver_compliant / $swver_total) * 100;
    $zpct_t    = sprintf("%.2f",$zpct_t);
    print "<tr bgcolor=slate><th colspan=99> $fs <font size=2> 
      DBMS: $this_dbms Compliance: Total $swver_compliant/$swver_total = ${zpct_t}% </font>";
  }

  print "</table>";
  &msg("Total instances: $gtotal_count");
}

#-----------------------------------------------------------------------------
sub IntHandler
#-----------------------------------------------------------------------------
{
   local($Signal) = @_;
   print "Signal=$Signal\n";
   exit(0);
}

#-----------------------------------------------------------------------------
sub error_html 
#-----------------------------------------------------------------------------
{
   $manyerrors = @error_list;
   $str= "" ;
   $str1="";
   $str2="";
   $str4=" <h2>Insufficient or missing information...</h2>";
   $html_str=$str.$str1.$str2.$str1.$str4;
   print "$html_str\n";
   #print "<h2>Insufficient or missing information...";
   print "<br>\n";
   print "Please correct the following:</h2>";
   print "<p>\n";
   print "<hr><ul>\n";
   foreach( @error_list) {
      print "<li> $_\n<br>";
   }
   print "</ul>\n";
   print "<hr>\n";
   if ($manyerrors > 3) {
      print "$manyerrors errors - Having a bad day, are we?<p>\n";
   }
   else {
      print "$manyerrors corrections to make.<p>\n";
   }
      
}

#-------------------------------------------------------------------------
#
# Main
#
#-------------------------------------------------------------------------

##system("echo '' | mailx -s 'monitor--$P ($ENV{'REMOTE_HOST'}) [AUTO]' border\@dba.it.thecompany.com");

&get_request;

@words = split(/,/,$ARGV[0]);
$in_mode = $words[0];

print "Content-type: text/html\n\n
  <title>DBAmon Task Detail: $in_mode</title>
  <body bgcolor=white link=darkblue vlink=darkblue><font face=$font>
  <table width=750><tr><td><img src='/dbamon/img/dbamonlogo.jpg' width=750>
  <tr bgcolor=wheat><td><font face=$font size=4>
      <center>DBAmon Task Detail - Mode: $in_mode</center>
  </table>";

$links_include = `cat /opt/dbamon/lib/trans_links.txt`;
print "
</table>
<table width=750>

 $links_include

</table>
<hr>
";

#---- Connect to DB
&connectDB;
&makeReport;

print "<hr>";
&msg("Done",1);

exit 0;
