#!/usr/local/bin/perl
$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools:/opt/dbamon/bin";
#-------------------------------------------------------------------------
#    Name:  dbamon_proj_growth.pl
#-------------------------------------------------------------------------
#
# Changes 
#
# 1.00 23Jun14 BB - Initial
#-------------------------------------------------------------------------
$version = "1.00"; 
$| = 1;
chop($P = `basename $0`); 
$P =~ s/\.pl$//g;

push(@INC,"/opt/dbamon/lib");

require "cgi_handlers.pl";
require "subs.pl";
require "subsDB.pl";
require "subsWWW.pl";

$from_days = 30;  #---- Default and for the menu
$stop_displaying = 0;

$debug = 0; 

#---- Max these vars global
$in_categ = "";  

#---- PL and CSV Vars and FILES - Start - Should only happen 1 time
mkdir "/opt/dbamon/dat/dyn" if (! -e "/opt/dbamon/dat/dyn"); 
system("ln -s /opt/dbamon/dat/dyn /opt/dbamon/htm/dyn") if ! -e "/opt/dbamon/htm/dyn"; 

$pl_date = getdate(); 
$pl_date =~ s/\///g;
$pl_date =~ s/\://g;
$pl_date =~ s/\-/_/;
##$zdiag .= "new pl_date=($pl_date)\n"; 

$tmpdata = "/tmp/${P}_tmpdata_$$.txt"; 
$tmpout  = "/tmp/${P}_tmpout_$$.txt"; 

#---- Read WWW_Font:

#---- Old
#chop($font = `grep 'WWW_Font:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
#if ($font =~ /%/)
#{
#  $font =~ s/%/ /g;
#  $font = "'$font'";
#}
#$zdiag .= "old font=($font)\n"; 

#---- New
$font                 = &readRC("WWW_Font:");
#$table_metrics_hourly = &readRC("Table_METRICS_HOURLY:");
#$table_detail_retain  = &readRC("Table_Detail_Retain_Days:");
#$table_detail_retain  = 30 if ! $table_detail_retain; 

##$zdiag .= "new font=($font)\n"; 

$font = "arial" if ! $font;

#---- Set connect string and hostname for URLs
if ($ENV{'HTTPS'} eq "on") { $http_prefix = "https://"; } 
else                       { $http_prefix = "http://"; } 
$http_host = $http_prefix . $ENV{'HTTP_HOST'};

$script_name = $ENV{'SCRIPT_NAME'};

#---- Trap an interrupt signal and clean up
$SIG{'INT'} = 'IntHandler';

use DBI;
require "cgi_handlers.pl";

#-----------------------------------------------------------------------------
sub logMsg
#-----------------------------------------------------------------------------
{
  my ($ls_key1, $ls_key2, $ls_key3, $ls_data) = @_;
  my $sql  = "insert into dbamon.log (lo_key1, lo_key2, lo_key3, lo_data) values (\'$ls_key1\', \'$ls_key2\', \'$ls_key3\', \'$ls_data\')";
  $dbh->do($sql) || &error('Failed_on_DB_do_insert_L300');
}

#-----------------------------------------------------------------------------
sub projectSpace
#-----------------------------------------------------------------------------
{
  if ($dayshist > 0) { $days_history = $dayshist; } 
  else               { $days_history = 180; }
  &msg("projectSpace - Starting - verb=$verb days_history=$days_history"); 
  $s_time = time;
  
  $sql  = "
    SELECT  il1.max AS Val_First,
	    il2.max AS Val_Last,
		    il2.max - il1.max AS Diff_Space_MB_Tot,
		    il3.*,
		    (il2.max - il1.max) / il3.days AS Space_MB_Growth_Per_Day
    FROM    ( SELECT    max
	      FROM      dbamon.dbamon.METRICS_DAILY
	      WHERE     instance = '$instance'
			AND dbamonmode = '$mode'
			AND category = 'PERF_SQL_TOT_SPACE_OBJECTS_MB'
			AND parm = '.'
			AND ts = ( SELECT   MIN(ts)
				   FROM     dbamon.dbamon.METRICS_DAILY
				   WHERE    instance = '$instance'
					    AND dbamonmode = '$mode'
					    AND category = 'PERF_SQL_TOT_SPACE_OBJECTS_MB'
					    AND parm = '.'
                                            and ts > dateadd(dd, -$days_history, getdate())
				 )
	    ) IL1 ,
	    ( SELECT    max
	      FROM      dbamon.dbamon.METRICS_DAILY
	      WHERE     instance = '$instance'
			AND dbamonmode = '$mode'
			AND category = 'PERF_SQL_TOT_SPACE_OBJECTS_MB'
			AND parm = '.'
			AND ts = ( SELECT   MAX(ts)
				   FROM     dbamon.dbamon.METRICS_DAILY
				   WHERE    instance = '$instance'
					    AND dbamonmode = '$mode'
					    AND category = 'PERF_SQL_TOT_SPACE_OBJECTS_MB'
					    AND parm = '.'
                                            and ts > dateadd(dd, -$days_history, getdate())
				 )
	    ) IL2,
	    ( SELECT    DATEDIFF(dd, min(ts), max(ts)) AS DAYS,
		            min(ts) AS Min_TS,
				    max(ts) AS Max_TS
          FROM      dbamon.dbamon.METRICS_DAILY
          WHERE     instance = '$instance'
                    AND dbamonmode = '$mode'
                    AND category = 'PERF_SQL_TOT_SPACE_OBJECTS_MB'
                    AND parm = '.'
                                            and ts > dateadd(dd, -$days_history, getdate())
        ) IL3
    ";

  &msg("Querying DBAMON.METRICS_DAILY data for instance_key=($instance) and mode=$mode");

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $e_time = time;
  $elapsed = $e_time - $s_time;
  #&msg("Query elapsed time: $elapsed seconds - Creating a chart for each metric...<br>");

  $selectcount = 0;

  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++; 

    $val_first        = shift(@Data);  
    $val_last         = shift(@Data);  
    $tot_growth_mb    = shift(@Data);  
    $tot_days         = shift(@Data);  
    $min_ts           = shift(@Data);  
    $max_ts           = shift(@Data);  
    $growth_daily_mb  = shift(@Data);  

    $val_first_gb    = sprintf("%.2f", $val_first / 1024); 
    $val_last_gb     = sprintf("%.2f", $val_last / 1024); 
    $tot_growth_gb   = sprintf("%.2f", $tot_growth_mb / 1024); 
    $growth_daily_gb = sprintf("%.2f", $growth_daily_mb / 1024); 

    $annual_growth_gb  = sprintf("%.2f", $growth_daily_gb * 365.24); 
    $annual_growth_pct = sprintf("%.2f", (($growth_daily_gb * 365.24) / $val_first_gb) * 100); 
  
    &msg("val_first=$val_first val_last=$val_last tot_growth_mb=$tot_growth_mb tot_days=$tot_days min_ts=$min_ts max_ts=$max_ts growth_daily_mb=$growth_daily_mb"); 
  }

  if ($selectcount == 0) 
  {
    &msg("Something is WRONG - No rows returned"); 
    return; 
  }

  print "
  <p></b>
  <span $style_normal>

<b>
The purpose of this report is to take current and <i>$days_history days ago</i> MSSQL Instance Size (Total Object Size) readings and 
project the calculated current growth rate into the future. 
</b>
<p>
<hr>

  <span $style_normal>
<h3> Instance Size Statistics (From Actual Data - Last $days_history Days):  </h3>
  <table bgcolor=wheat border=0 $style_normal>
  <tr bgcolor=cadetblue>
    <th> <span $style_normal>Metric 
    <th> <span $style_normal>Value
    <th> <span $style_normal>Notes

  <tr bgcolor=linen>
    <td>             <span $style_normal>MSSQL Instance:
    <td align=right> <span $style_normal> <b>$instance </b>
    <td>             <span $style_normal> &nbsp; Mode: $mode &nbsp; 
  <tr bgcolor=linen>
    <td>             <span $style_normal>First Value - Instance Size:
    <td align=right> <span $style_normal> <b>$val_first_gb (GB)  </b>
    <td>             <span $style_normal>&nbsp; As of $min_ts ($tot_days days ago) - DBAmon Performance Metric PERF_SQL_TOT_SPACE_OBJECTS_MB maximum  &nbsp; 
  <tr bgcolor=linen>
    <td>             <span $style_normal>Last Value - Instance Size: 
    <td align=right> <span $style_normal> <b>$val_last_gb (GB)  </b>
    <td>             <span $style_normal>&nbsp; As of $max_ts (current value)- DBAmon Performance Metric PERF_SQL_TOT_SPACE_OBJECTS_MB maximum value   &nbsp; 
  <tr bgcolor=linen>
    <td>             <span $style_normal>Total Growth: 
    <td align=right> <span $style_normal> <b>$tot_growth_gb (GB)  </b>
    <td align=left > <span $style_normal> &nbsp; Current Size ($val_last_gb (GB)) - Initial Size ($val_first_gb (GB))   &nbsp;
  <tr bgcolor=linen>
    <td>             <span $style_normal>Growth per Day: 
    <td align=right> <span $style_normal> <b>$growth_daily_gb (GB)  </b>
    <td align=left > <span $style_normal> &nbsp; Total Growth Amount ($tot_growth_gb (GB)) / $tot_days Days  &nbsp;
  <tr bgcolor=linen>
    <td>             <span $style_normal>Annual Growth Amount: 
    <td align=right> <span $style_normal> <b>$annual_growth_gb (GB)  </b>
    <td align=left > <span $style_normal> &nbsp; Daily Growth Amount ($growth_daily_gb (GB)) * 365.24 &nbsp;
  <tr bgcolor=linen>
    <td>             <span $style_normal>Annual Growth Rate: 
    <td align=right> <span $style_normal> <b>${annual_growth_pct}% </b>
    <td align=left > <span $style_normal> &nbsp; Annual Growth Amount ($annual_growth_gb (GB)) / First Value: ($val_first_gb (GB)) &nbsp; 

  </table>
  "; 

  #---- Projections
  #$this_date = substr(getdate(), 0,10); 
  $instance_size_gb = $val_last_gb; 
  $incr_growth_gb = 0; 
  $this_date = getdate();
  $this_date_num = &timeToNum($this_date); 
  &msg("DEBUG - Starting this_date=$this_date this_date_num=$this_date_num instance_size_gb=$instance_size_gb") if $debug; 

  $days_to_add = 90; 
  $iter_max = 41; 
  $proj_content = ""; 
  $days_sofar = 0; 
  $months_sofar = 0; 
  $years_sofar = 0; 
  
  for ($i=0 ; $i < $iter_max; $i++)
  {
    $days_sofar += $days_to_add; 
    $months_sofar = $days_sofar / 30; 
    $years_sofar = sprintf("%.2f", $days_sofar / 365.24); 

    $incr_growth_gb   += ($growth_daily_gb * $days_to_add); 
    $instance_size_gb += ($growth_daily_gb * $days_to_add); 
    $this_date_num    += (86400 * $days_to_add);  

    $this_date = &timeToText($this_date_num); 

    $this_date_out = substr($this_date,0,10); 
    $incr_growth_gb_out = sprintf("%.2f", $incr_growth_gb); 
    $instance_size_ratio = sprintf("%.2f", ($instance_size_gb / $val_last_gb) * 100); 
    $instance_size_gb_out = sprintf("%.2f", $instance_size_gb); 

    &msg("DEBUG - add_days=$add_days - this_date=$this_date this_date_num=$this_date_num instance_size_gb=$instance_size_gb incr_growth_gb=$incr_growth_gb") if $debug; 

    if ($instance_size_gb_out < 0) { $size_color = "lightpink"; }
    else                           { $size_color = ""; }

    $proj_content .= "<tr bgcolor=linen>
    <td>             <span $style_normal> <b>$this_date_out  </b>
    <td align=right> <span $style_normal>$days_sofar 
    <td align=right> <span $style_normal>$months_sofar 
    <td align=right> <span $style_normal>$years_sofar 
    <td align=right bgcolor=$size_color> <span $style_normal> <b>$incr_growth_gb_out (GB)  </b>
    <td align=right> <span $style_normal> <b>$instance_size_gb_out (GB)  </b>
    <td align=right> <span $style_normal> <b>${instance_size_ratio}% </b>
    "; 
  } 

  print "
  <br>&nbsp;
  <p></b>
  <span $style_normal>

<h3> Projected Instance Size (Based on the Current Rate of Growth: $growth_daily_gb GB/Day):  </h3>
  <table bgcolor=wheat border=0 $style_normal>
  <tr bgcolor=cadetblue>
    <th> <span $style_normal> Date of Projection <br>($days_to_add Day Increments)
    <th colspan=3> <span $style_normal> How Far Into The Future? 
    <th> <span $style_normal> Cumulative Projected Growth<br> (\@ $growth_daily_gb (GB)/Day)
    <th> <span $style_normal> Projected Instance Size 
    <th> <span $style_normal> Projected Instance Size<br> vs. Current Instance Size
  <tr bgcolor=cadetblue>
    <th> <span $style_normal> &nbsp; 
    <th> <span $style_normal> Days 
    <th> <span $style_normal> Months 
    <th> <span $style_normal> Years 
    <th> <span $style_normal> &nbsp; 
    <th> <span $style_normal> &nbsp; 
    <th> <span $style_normal> &nbsp; 

$proj_content

  </table>
  "; 

  $el_time = time - $s_time;
  &msg("projectSpace - Done - el_time=$el_time");
}

#----------------------------------------------------------------------
sub chartMetric
#----------------------------------------------------------------------
{
  my $eg_categ = $_[0]; 
  my $eg_parm  = $_[1]; 

  my $eg_debug = 0; 

  &msg("DEBUG - eventGraphPerf - Starting - eg_thishost=$eg_thishost eg_metric=$eg_metric eg_title=$eg_title") if $eg_debug;

  ##             ORDER BY 1 ";
  ## $sql = "SELECT zdate_char, $from_column 
  $sql = "SELECT  dbamon.dbamon.dateconvert_19(ts), $from_column 
              FROM      dbamon.dbamon.$from_table
              WHERE     dbamonmode = '$mode'
                        AND category = '$eg_categ' 
                        and parm     = '$eg_parm'
                        and instance = '$instance'
                        and ts > dateadd(dd, -$from_days, getdate())
  ";

  &msg("DEBUG - Running sql=$sql") if $eg_debug; 

  $sth = $dbh->prepare($sql) || &error('sql_659');
  $sth->execute || &error('sql_660');

  open(DOUT, ">$tmpdata") || &error("Cannot open output tmpdata=$tmpdata - $!");

  my $rows = 0;
  %rowcache = (); 

  while (@Data = $sth->fetchrow_array)
  {
    $ts  = $Data[0];
    $val = $Data[1];

    #---- Edit ts to the format that ploticus likes
    $ts = substr($ts,0,16); 
    $ts =~ s/\-/\./; 

    $rowcache{$ts} = $val; 
  }

  foreach $this_ts ( sort keys %rowcache )
  {
    print DOUT "$this_ts $rowcache{$this_ts}\n";
    $rows++;
  }

  close(DOUT);
  &msg("Wrote sortkeys $rows records to $tmpdata") if $eg_debug;
  $moving_avg = int($rows / 5); 

  if ($eg_debug)
  {
    &msg("Last 10 lines of tmpdata:");
    system("tail -10 $tmpdata");
  }

  #chdir("/opt/dbamon/ploticus");

  $ENV{'DBAMON_PL_FILE'}           = $tmpdata;
  $ENV{'DBAMON_PL_TITLE1'}         = "Instance: $instance" ;
  $ENV{'DBAMON_PL_TITLE2'}         = "Metric: $eg_categ/$eg_parm - $title2";
  $ENV{'DBAMON_PL_MOVINGAVGCOUNT'} = $moving_avg;
  $ENV{'DBAMON_PL_LASTVAL'}        = $val;

  $cmd = "/opt/dbamon/ploticus/dbamon_pl_run SingleLineUserTitles";
  ##$cmd = "dbamon_pl_run SingleLine";  # TEST

  &msg("Invoking Ploticus - cmd=($cmd)") if $eg_debug;
  $rc = system("$cmd > $tmpout 2>&1");
  &msg("Back from dbamon_pl_run - rc=$rc") if $eg_debug;
  system("cat $tmpout") if $eg_debug;
  &error("Ploticus failed - rc=$rc") if $rc != 0;

  #---- Find PNG_File: name
  open(CMDOUT, "$tmpout") || &error("Cannot open input - tmpout=$tmpout - $!");
  while(<CMDOUT>)
  {
    if (/^PNG_File:/)
    {
      @words = split;
      $png_file = $words[1];
    }
  }

  $png_file_url  = "/dbamon/graphs/dyn/$png_file" if $png_file;
  &msg("Returning PNG file - png_file=$png_file - png_file_long=$png_file_long") if $eg_debug;

  ##&msg("Chart: <br><img src=$png_file_url>");  
  $html_out .= "<hr><h3> Chart $chartcount of $selectcount - $categ/$parm: </h3> 
<img src=$png_file_url width=610>
  ";  
}

#-----------------------------------------------------------------------------
sub IntHandler
#-----------------------------------------------------------------------------
{
   local($Signal) = @_;
   print "Signal=$Signal\n";
   exit(0);
}

#-----------------------------------------------------------------------------
sub error_html 
#-----------------------------------------------------------------------------
{
   $manyerrors = @error_list;
   $str= "" ;
   $str1="";
   $str2="";
   $str4=" <h2>Insufficient or missing information...</h2>";
   $html_str=$str.$str1.$str2.$str1.$str4;
   print "$html_str\n";
   #print "<h2>Insufficient or missing information...";
   print "<br>\n";
   print "Please correct the following:</h2>";
   print "<p>\n";
   print "<hr><ul>\n";
   foreach( @error_list) {
      print "<li> $_\n<br>";
   }
   print "</ul>\n";
   print "<hr>\n";
   if ($manyerrors > 3) {
      print "$manyerrors errors - Having a bad day, are we?<p>\n";
   }
   else {
      print "$manyerrors corrections to make.<p>\n";
   }
}

#-----------------------------------------------------------------------------
#
# Main
#
#-----------------------------------------------------------------------------

&get_request;

@words = split(/,/,$ARGV[0]);
$mode     = $words[0];
$instance = $words[1];
$dayshist = $words[2];

&header("MSSQL Instance Growth Projections") unless $ENV{'DBAMON_NOWEB'}; 

&msg("Starting - version=$version - mode=($mode) verb=($verb) instance=($instance) dayshist=($dayshist) - http_host=($http_host) script_name=$script_name");

&connectDB;

#---- Call according to parms passed 
if (! $mode) { &error("MODE (1st parm) Must be specified"); }
if (! $instance) { &error("INSTANCE (2nd parm) Must be specified"); }

#---- Log a message
&logMsg("WWWMonitor", $P, $ENV{'REMOTE_ADDR'}, "Starting - instance=$instance verb=$verb");

#---- Run calculator
&projectSpace; 

#---- Terminate
&msg("Done");
unlink "$tmpdata", "$tmpout"; 
exit 0;
