#!/usr/local/bin/perl
#--------------------------------------------------------------------------------
sub summarizePulldownEval
{
  ($what) = @_;
  $z = "push \@pdmenu_${pd_dbms}_$what, \$pd_$what;";
  print "z=$z\n" if $pd_debug;
  eval "$z";
}

sub summarizePulldownUndef
{
  local ($z_dbms) = @_;
  $z = "undef \@pdmenu_${z_dbms}_section;"; eval "$z";
  $z = "undef \@pdmenu_${z_dbms}_option;";  eval "$z";
  $z = "undef \@pdmenu_${z_dbms}_desc;";    eval "$z";
}

sub summarizePulldown
{
  $pd_options = "";
  $pd_debug = 0;

  # Read adm/pulldown.txt config file
  if ($i_rm == 1)
  {
    &summarizePulldownUndef("oracledbux");
    &summarizePulldownUndef("oracledbnt");
    &summarizePulldownUndef("mssql");
    &summarizePulldownUndef("sap");
    &summarizePulldownUndef("oracleapps");
    &summarizePulldownUndef("informixux");

    open(BDF, "/opt/dbamon/adm/pulldown.txt") || &logit("Cannot open pulldown.txt config file - $!");
    while(<BDF>)
    {
      @words = split('\|',$_);
      $pd_dbms    = $words[1];
      $pd_section = $words[3];
      $pd_option  = $words[5];
      $pd_desc    = $words[7];
      print "pd_dbms=$pd_dbms pd_section=$pd_section pd_option=$pd_option pd_desc=$pd_desc\n" if $pd_debug;

      &summarizePulldownEval("section");
      &summarizePulldownEval("option");
      &summarizePulldownEval("desc");
    }
  }

  $dbms_coded = "";
  $dbms_coded = "oracledbux" if $dbms[$i_rm] eq "Oracle";
  $dbms_coded = "oracledbnt" if $dbms[$i_rm] eq "OracleNT";
  $dbms_coded = "mssql"      if $dbms[$i_rm] eq "MSSQL";
  $dbms_coded = "sap"        if $dbms[$i_rm] eq "SAP";
  $dbms_coded = "oracleapps" if $dbms[$i_rm] eq "OracleApps";
  $dbms_coded = "informixux" if $dbms[$i_rm] eq "Informix";
  $dbms_coded = "oswin"      if $dbms[$i_rm] eq "OSWin";
  print "dbms_coded=$dbms_coded\n" if $pd_debug;
  if ($dbms_coded eq "")
  {
    &error_msg("Could not decode dbms[$i_rm] value of $dbms[$i_rm]");
  }

  # Count the number of entries for this dbms
  $z = "\$pd_count = \$#pdmenu_${dbms_coded}_section;";
  print "z=$z\n" if $pd_debug;
  eval $z;
  print "pd_count=$pd_count\n" if $pd_debug;

  $pd_d = 0;
  $pd_a = 0;
  $pd_m = 0;
  $pd_options = "<option selected>\n";

  for ($zi = 0; $zi <= $pd_count; $zi++)
  {
    $z = "\$pd_section = \@pdmenu_${dbms_coded}_section[$zi];";       eval $z; print "z=$z\n" if $pd_debug;
    $z = "\$pd_option  = \@pdmenu_${dbms_coded}_option[$zi];";        eval $z; print "z=$z\n" if $pd_debug;
    $z = "\$pd_desc    = \@pdmenu_${dbms_coded}_desc[$zi];";          eval $z; print "z=$z\n" if $pd_debug;
    print "pd_section=$pd_section pd_option=$pd_option pd_desc=$pd_desc\n" if $pd_debug;

    if ($pd_d == 0 && $pd_section eq "D")
    {
      $pd_options .= "<option STYLE='background: black; color: white'>Display Commands\n";
      $pd_d = 1;
    }
    if ($pd_a == 0 && $pd_section eq "A")
    {
      $pd_options .= "<option STYLE='background: black; color: white'>Alter Commands\n";
      $pd_a = 1;
    }
    if ($pd_m == 0 && $pd_section eq "M")
    {
      $pd_options .= "<option STYLE='background: black; color: white'>Menus\n";
      $pd_m = 1;
    }

    #$pd_options .= "<option value='/cgi-bin/dbamon_magnify_run.pl?$pd_option,$modeout,$i_rm,$ck,$titleraw[$i_rm],$dbms_coded,$pd_section'>[$pd_option] $pd_desc\n";
    $pd_options .= "<option value='/cgi-bin/dbamon_magnify_run.pl?$pd_option,$mode,$dbcfilenameshort[$i_rm],.,$titleraw[$i_rm],$dbms_coded,$pd_section'>[$pd_option] $pd_desc</option>\n";

  }

  print "pd_options=$pd_options\n" if $pd_debug;

  return;
}
#--------------------------------------------------------------------------------
1;
