#set P = d1

#shell #processrows
  date +%Y/%m/%d-%H:%M:%S
#endshell
#call $shellrow ( thedate )

#shell #processrows
  echo $THIS_TARGET 
#endshell
#call $shellrow ( thetarget )

#proc getdata
  file: @P.data

#proc settings
  numbernotation: us

#proc page
  textsize: 10
//  font: times
  outfilename: @P.png
//  backgroundcolor: white
  pagesize: 6 4
//  titledetails: align=right  adjust=-2.0,-3.10 size=6
  title: Program: @P  Created: @thedate  Obs: @NRECORDS 

// #proc image
//   file: ./hplogo2.gif
//   location: 0.1 0.8 
//   width: 65
//   height: 55

#proc areadef
  title: GG Lag Details - Host: @thetarget 
  titledetails: align=center size=15 color=darkblue style=B adjust=0,0.25 
  xscaletype: datetime yyyy/mm/dd.hh:mm
  xautorange: datafield=1
  yautorange: datafield=2
  rectangle: 1 1 7 5

  xaxis.stubvert: yes 
  xaxis.stubs: inc 
  xaxis.stubs: datetimematic 
  xaxis.minortics: none 
  xaxis.labeldistance: 1.6
  xaxis.grid: width=0.1  style=1
  xaxis.autodays: no 
  xaxis.autoyears: no 
  xaxis.automonths: no 
  xaxis.labeldetails: size=7 color=darkblue style=B 
  xaxis.stubformat: yyyy/mm/dd

  yaxis.labeldetails: size=8 color=darkblue style=B
  yaxis.labeldistance: 0.7
  yaxis.grid: width=0.1  style=1
  yaxis.stubs: inc
  yaxis.label: Max Lag (Mins.) 

#proc lineplot
  xfield: 1
  yfield: 2
  legendlabel: Max\nLag /\nSample
  linedetails: color=blue width=0.2 
  
// compute and render moving average curve using proc curvefit
 #proc curvefit
   xfield: 1
   yfield: 2
   order: 864
   curvetype: movingavg 
   maxinpoints: 10000
   legendlabel: 3 Day\nMoving\nAvg
   linedetails: color=red width=1.5 

#proc legend
  location: max+0.7 max-0.5 
  format: down

//  xaxis.stubs: list Jul\nAug\nSep\nOct\nNov\nDec
//  xrange: 2010/01 2010/12
//  xaxis.autoyears: yyyy 
//  xaxis.stubs: inc 1  month
//  xaxis.stubrange: 201007 201012
//  xaxis.stubformat: YYYY/MM
//  xaxis.automonths: mm 
//  font: clb9x15
//  titledetails: align=right  adjust=0.3,-3.15 size=7
//  frame: bevel
//  yaxis.stubs: incremental 500
//  xaxis.label: Date 
//  xaxis.labeldistance: 0.9
//  pointsymbol: shape=pixtriangle  style=filled radius=0.02 color=blue
